
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mman.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <malloc.h>
#include <fcntl.h>
#include <time.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <unistd.h>
#include <linux/types.h>
#include <linux/dirent.h>
#include <linux/unistd.h>

#define BLOCK 1024
#define TUXSTAT "/proc/net/tux/stat"
char buf [BLOCK+10];
int main (int argc, char **argv)
{
	struct hostent *entry;
	int fd, len, parsed_chars, printed_chars;
	char *tmp;
	unsigned int proto, req, atom_idx, error, status, file_len, file_pos;
	unsigned int ftp_comm, parsed_len, header_len, objectname_len;
	char atom0[10], atom1[10], state_bits[10];
	char client_addr[30], data_sock[30];
	char objectname[BLOCK];
	unsigned int d1,d2,d3,d4,d5,d6;
	unsigned int host_addr, sock_ptr, sk_ptr, data_sock_ptr, data_sk_ptr;
	int dns_lookup;

	dns_lookup = 1;
	if (argc >= 2)
		if (!strcmp(argv[1],"-n"))
			dns_lookup = 0;

#if 1
	fd = open(TUXSTAT, O_RDONLY);
#else
	fd = open("stat", O_RDONLY);
#endif
	if (fd < 0) {
		perror(TUXSTAT);
		return -1;
	}
repeat:
	len = read(fd, buf, BLOCK);
	if (!len)
		return 0;
	if (len != BLOCK)
		return -1;
	tmp = buf;
	sscanf(tmp, "%i %08x %i %s %s %s %i %i %d:%d.%d.%d.%d:%d %i %i%n", &proto, &req, &atom_idx, atom0, atom1, state_bits, &error, &status, &d1, &d2,&d3,&d4,&d5, &d6, &file_len, &file_pos,&parsed_chars);
	tmp += parsed_chars;
	if (proto == 1) {
		sscanf(tmp, "%i %s %n", &ftp_comm, data_sock, &parsed_chars);
		tmp += parsed_chars;
	}
	sscanf(tmp, "%08x/%08x %08x/%08x %n", &sock_ptr, &sk_ptr, &data_sock_ptr, &data_sk_ptr, &parsed_chars);
	tmp += parsed_chars;
	sscanf(tmp, "%i\n%i%n", &parsed_len, &header_len, &parsed_chars);
	tmp += parsed_chars;
	tmp += header_len;
	sscanf(tmp, "%i\n%n", &objectname_len, &parsed_chars);
	tmp += parsed_chars;
	if (objectname_len) {
		sscanf(tmp, "%s\n%n", objectname, &parsed_chars);
		tmp += parsed_chars;
	}

	if ((proto == 1) && (ftp_comm == 14) && objectname_len && file_len) {
		printf("%7dK /%7dK (%2.1f%%)%n", file_len/1024, file_pos/1024, 100.0 * (double)file_pos / (double)file_len, &printed_chars);
		printf("%-*s", 28-printed_chars, "");
		sprintf(client_addr, "%d.%d.%d.%d", d2, d3, d4, d5);
		((char *)&host_addr)[0] = d2;
		((char *)&host_addr)[1] = d3;
		((char *)&host_addr)[2] = d4;
		((char *)&host_addr)[3] = d5;
		entry = NULL;
		if (dns_lookup)
			entry = gethostbyaddr(&host_addr,sizeof(host_addr),AF_INET);
		printf("%s %s\n", entry ? entry->h_name : client_addr, objectname);
	}
#if 0	
	printf("\n%i req:%08x idx:%i atom0:%s atom1:%s state_bits:%s err:%i status:%i client_addr:%s file_len:%i file_pos%i (%d)\n", proto, req, atom_idx, atom0, atom1, state_bits, error, status, client_addr, file_len, file_pos, parsed_chars);
	printf("ftpcomm:%d data_sock:%s, sock1:%s sock2:%s\n", ftp_comm, data_sock, sock1, sock2);
	printf("parsed_len:%i header_len:%i\n", parsed_len, header_len);
	printf("objectname_len:%i objectname:{%s}\n", objectname_len, objectname);
#endif
	goto repeat;

	return 0;
}
